#!/bin/sh
#| ;;; tests.sh -*- Scheme -*-
csc $0 -k -c++ "$@" -o a.out -DDBGALLOC -D crunch-debug && ./a.out
exit
|#

(use testeez crunch)

(testeez 
 "crunch"

 (test-define
  "compile fac" 
  fac
  (let ()
    (crunch 
     (define (fac n)
       (if (zero? n)
	   1
	   (* n (fac (sub1 n))))))
    fac) )

 (test/equal "run fac" (fac 10) 3628800)

 (test-define 
  "compile tak"
  tak
  (let ()
    (crunch
     (define (tak x y z)
       (if (not (< y x))
	   z
	   (tak (tak (- x 1) y z)
		(tak (- y 1) z x)
		(tak (- z 1) x y) ))))
    tak) )

 (test/equal "run tak" (tak 18 12 6) 7)

 (test/equal 
  "simple loop" 
  (let ()
    (crunch
     (define (loop m)
       (let ((count 0))
	 (do ((n m (sub1 n)))
	     ((zero? n) (newline))
	   (write-char #\.)
	   (set! count (add1 count)))
	 count)) )
    (loop 10))
  10)

 (test-eval
  "loop/case"
  (crunch
   (do ((i 0 (add1 i)))
       ((>= i 10))
     (case (bitwise-and i #x3)
       ((0) (display "zero\n"))
       ((1) (display "one\n"))
       ((2) (display "two\n"))
       ((3) (display "three\n"))))))

 (test/equal "crunch file fft" (system "csi -s chicken-crunch.scm fft.scm -d -o fft && ./fft") 0)

 (test/equal
  "string reverse"
  (let ()
    (crunch
     (define (string-reverse str)
       (let* ((n (string-length str))
	      (s2 (make-string n #\space)))
	 (do ((i 0 (add1 i)))
	     ((>= i n))
	   (string-set! s2 (sub1 (- n i)) (string-ref str i)))
	 s2)) )
    (string-reverse "this is a test!"))
  "!tset a si siht")

 (test/equal "crunch numbers" (system "csi -s chicken-crunch.scm numbers.scm -d -o numbers && ./numbers") 0)

)
